var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/math/index.ts
var math_exports = {};
__export(math_exports, {
  MathEngine: () => MathEngine,
  createMathRenderer: () => createMathRenderer
});
module.exports = __toCommonJS(math_exports);

// src/math/impl.ts
var import_load_script_css = require("@cnblogs/load-script-css");

// src/math/model.ts
var MathEngine = /* @__PURE__ */ ((MathEngine2) => {
  MathEngine2[MathEngine2["MathJax2"] = 0] = "MathJax2";
  MathEngine2[MathEngine2["MathJax3"] = 1] = "MathJax3";
  MathEngine2[MathEngine2["Katex"] = 2] = "Katex";
  return MathEngine2;
})(MathEngine || {});
var defaultConfig = {
  [0 /* MathJax2 */]: {
    entryScript: "https://mathjax.cnblogs.com/2_7_5/MathJax.js?config=TeX-AMS_CHTML&delayStartupUntil=configured&v=20200504",
    document: window.document,
    engine: 0 /* MathJax2 */,
    isEnabled: true
  },
  [1 /* MathJax3 */]: {
    entryScript: "https://mathjax.cnblogs.com/3_2_1/es5/tex-mml-chtml.js",
    document: window.document,
    engine: 1 /* MathJax3 */,
    isEnabled: true
  },
  [2 /* Katex */]: {
    entryScript: "https://common.cnblogs.com/katex/0.16.8/katex.min.js",
    document: window.document,
    engine: 2 /* Katex */,
    isEnabled: true
  }
};

// src/math/impl.ts
var Mathjax2Renderer = class {
  _defaultConfig = defaultConfig[0 /* MathJax2 */];
  _defaultMathJaxConfig = {
    tex2jax: {
      inlineMath: [
        ["$", "$"],
        ["\\(", "\\)"]
      ],
      processClass: "math",
      processEscapes: true
    },
    TeX: {
      equationNumbers: {
        autoNumber: "AMS",
        useLabelIds: true
      },
      extensions: ["extpfeil.js", "mediawiki-texvc.js"],
      Macros: { bm: "\\boldsymbol" }
    },
    CommonHTML: { linebreaks: { automatic: true } },
    "HTML-CSS": { linebreaks: { automatic: true } },
    SVG: { linebreaks: { automatic: true } },
    skipStartupTypeset: true
  };
  _config = this._defaultConfig;
  _initTask;
  get _global() {
    return this._config.document.defaultView ?? window;
  }
  render(container, callback) {
    if (!this._config.isEnabled)
      return Promise.resolve();
    return this.init().then((mathjax) => {
      if (!mathjax)
        return;
      const { onRendered } = this._config;
      mathjax.Hub.Queue(["Typeset", mathjax.Hub, container]);
      if (onRendered != null) {
        mathjax.Hub.Queue(() => onRendered(mathjax));
      }
      if (callback) {
        mathjax.Hub.Queue(callback);
      }
    }).catch(console.warn);
  }
  config(value) {
    this._config = Object.assign({}, this._defaultConfig, value);
    return this;
  }
  init() {
    if (this._initTask)
      return this._initTask;
    const { entryScript, tapMathJaxConfig, document } = this._config;
    return this._initTask = (0, import_load_script_css.loadScript)({
      src: entryScript,
      id: "mathjax",
      timeoutSeconds: 10,
      appendTo: document.head
    }).then(() => {
      const { MathJax } = this._global;
      if (MathJax) {
        MathJax.Hub.Config(
          tapMathJaxConfig?.call(
            void 0,
            Object.assign({}, this._defaultMathJaxConfig)
          ) ?? {
            ...this._defaultMathJaxConfig
          }
        );
        MathJax.Hub.Configured();
        return MathJax;
      }
    }).catch(() => this._initTask = void 0);
  }
};
var MathJax3Renderer = class {
  _defaultConfig = defaultConfig[1 /* MathJax3 */];
  _defaultMathJaxConfig = {
    tex: {
      inlineMath: [
        ["$", "$"],
        ["\\(", "\\)"]
      ],
      processEscapes: true,
      tags: "ams",
      useLabelIds: true,
      macros: {
        bm: "\\boldsymbol"
      },
      packages: { "[+]": ["noerrors", "extpfeil"] }
    },
    options: {
      processHtmlClass: "math",
      ignoreHtmlClass: "tex2jax_ignore"
    },
    loader: {
      load: ["[tex]/noerrors", "[tex]/extpfeil"]
    },
    startup: {
      typeset: false
    }
  };
  _config = this._defaultConfig;
  _initTask;
  config(value) {
    this._config = Object.assign({}, this._defaultConfig, value);
    return this;
  }
  render(container, callback) {
    if (!this._config.isEnabled)
      return Promise.resolve();
    return this.init().then((mathjax) => {
      mathjax ? mathjax.startup.promise = mathjax.startup.promise.then(
        () => mathjax.typesetPromise([container]).then(() => {
          try {
            this._config.onRendered?.call(void 0, mathjax);
          } catch (e) {
            console.error(e);
          }
          try {
            callback?.call(void 0);
          } catch (e) {
            console.error(e);
          }
        })
      ) : void 0;
    }).catch(console.warn);
  }
  init() {
    return (this._initTask ??= new Promise((resolve, reject) => {
      const { entryScript, tapMathJaxConfig, document: _document } = this._config;
      const _window = _document.defaultView ?? window;
      _window.MathJax = tapMathJaxConfig?.call(void 0, {
        ...this._defaultMathJaxConfig
      }) ?? { ...this._defaultMathJaxConfig };
      if (!_window.MathJax.startup) {
        _window.MathJax.startup = {};
      }
      _window.MathJax.startup.ready = () => {
        _window.MathJax?.startup?.defaultReady();
        resolve(_window.MathJax);
      };
      (0, import_load_script_css.loadScript)({
        src: entryScript,
        id: "mathjax",
        executionStrategy: "defer",
        appendTo: _window.document.head
      }).catch(reject);
    })).catch(() => this._initTask = void 0);
  }
};
var KatexRenderer = class {
  _defaultConfig = defaultConfig[2 /* Katex */];
  _defaultKatexOptions = {
    delimiters: [
      { left: "$$", right: "$$", display: true },
      { left: "$", right: "$", display: false },
      { left: "\\(", right: "\\)", display: false },
      { left: "\\[", right: "\\]", display: true }
    ]
  };
  _config = this._defaultConfig;
  _katexOption = Object.assign({}, this._defaultKatexOptions);
  _initTask;
  get _global() {
    return this._config.document.defaultView ?? window;
  }
  config(value) {
    this._config = Object.assign({}, this._defaultConfig, value);
    return this;
  }
  async render(container, callback) {
    if (!this._config.isEnabled) {
      return Promise.resolve();
    }
    await this.init();
    const global = this._global;
    global.renderMathInElement(container, this._katexOption);
    if (callback) {
      callback();
    }
  }
  init() {
    return (this._initTask ??= new Promise((resolve, reject) => {
      const { entryScript, document: _document } = this._config;
      Promise.all([
        (0, import_load_script_css.loadCss)({
          href: "https://common.cnblogs.com/katex/0.16.8/katex.min.css",
          id: "katex-style",
          appendTo: _document.head
        }),
        (0, import_load_script_css.loadScript)({
          src: entryScript,
          id: "katex",
          appendTo: _document.head
        })
      ]).then(() => (0, import_load_script_css.loadScript)({
        src: "https://common.cnblogs.com/katex/0.16.8/contrib/auto-render.min.js",
        id: "katex-auto-render",
        appendTo: _document.head
      }).then(() => {
        this._katexOption = this._config.tapMathJaxConfig?.call(
          void 0,
          this._katexOption
        ) ?? {
          ...this._defaultKatexOptions
        };
        resolve();
      })).catch(reject);
    })).catch(() => this._initTask = void 0);
  }
};

// src/math/factory.ts
var createMathRenderer = (rendererConfig) => {
  switch (rendererConfig.engine) {
    case 0 /* MathJax2 */:
      return new Mathjax2Renderer().config(rendererConfig);
    case 1 /* MathJax3 */:
      return new MathJax3Renderer().config(rendererConfig);
    case 2 /* Katex */:
      return new KatexRenderer().config(rendererConfig);
    default:
      throw Error("Renderer unavailable");
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  MathEngine,
  createMathRenderer
});
